Clear-Host
[void][System.Reflection.Assembly]::LoadWithPartialName('Microsoft.SqlServer.SMO')
Import-Module "C:\Sources\KMO\bin\Release\KMO.dll" -Force


$myServer = New-Object ('Microsoft.SqlServer.Management.Smo.Server') '127.0.0.1,14330'
$myServer.ConnectionContext.LoginSecure = $false
$myServer.ConnectionContext.Login = 'guss'
$myServer.ConnectionContext.Password = 'Gu$$'

# Version
$myServer
[KMO.KServer]::VersionName($myServer)
[KMO.KServer]::VersionFull($myServer)


# Monitoring
[KMO.KServer]::GetWho($myServer)
[KMO.KServer]::GetWho($myServer) | Out-GridView
[KMO.KServer]::GetWho($myServer) | Out-File 'C:\temp\GetWho.txt'

[KMO.KServer]::GetLiveSession($myServer) | Out-GridView

# Sauvegardes
[KMO.KServer]::GetBackupHistory($myServer) | Out-GridView

# ErrorLog via SMO
$myServer.ReadErrorLog() 
# ErrorLog via KMO (En C#, les 2 mthodes s'appellent pareil, Powershell gre bizarrement les mthodes d'extension)
[KMO.KServer]::ReadErrorLog($myServer, [datetime]::Today, [datetime]::Now)
[KMO.KServer]::GetLoginFailed($myServer, [datetime]::Today, [datetime]::Now)

# Wait statistics
[KMO.KServer]::GetWaitStatistics($myServer) | Out-GridView
[KMO.KServer]::GetWaitStatistics($myServer, '') | Out-GridView

# Mmoire
[KMO.KServer]::GetBufferByDatabase($myServer) | Out-GridView

# CPU
[KMO.KServer]::GetCPUbyDatabase($myServer) | Out-GridView
[KMO.KServer]::GetCPUFromRing($myServer) | Out-GridView
# /!\ dm_os_ring_buffers ne serait plus support


# Disks
[KMO.KServer]::GetIOStatistics($myServer) | Out-GridView
[KMO.KServer]::GetFileTreeMaps($myServer) | Out-GridView


# securit
[KMO.KServer]::GetWhoIsSa($myServer) | Out-GridView


# performance tsql
[KMO.KServer]::GetTop50StoredProcedures($myServer) | Out-GridView
[KMO.KServer]::GetTop50Queries($myServer) | Out-GridView






$myDatabase = $myServer.Databases['AdventureWorks2014']

# replication. Cette information est disponible dans RMO pas dans SMO
[KMO.KDatabase]::IsDistributor($myDatabase)

# sauvegardes
[KMO.KDatabase]::GetBackupHistory($myDatabase) | Out-GridView

# Audits 
[KMO.KDatabase]::GetFKWithoutIndex($myDatabase) | Out-GridView
[KMO.KDatabase]::GetDuplicatedIndex($myDatabase) | Out-GridView    # excution un peu plus longue
[KMO.KDatabase]::GetHeapIndex($myDatabase) | Out-GridView
[KMO.KDatabase]::GetTableWithoutPK($myDatabase) | Out-GridView
[KMO.KDatabase]::GetTableWithoutClusteredIndex($myDatabase) | Out-GridView
[KMO.KDatabase]::GetLastAccessByTable($myDatabase) | Out-GridView

# mmoire
[KMO.KDatabase]::GetBufferStats($myDatabase) | Out-GridView



$myTable = $myDatabase.Tables['Address', 'Person']

# CRUD
[KMO.KTable]::ScriptProcedureSelect($myTable)
[KMO.KTable]::ScriptProcedureList($myTable)
[KMO.KTable]::ScriptProcedureDelete($myTable)
[KMO.KTable]::ScriptProcedureUpdate($myTable)
[KMO.KTable]::ScriptProcedureInsert($myTable)
[KMO.KTable]::ScriptProcedureSelectWithTVP($myTable)

# Checksum
[KMO.KTable]::DataChecksum($myTable)



$myColumn = $myTable.Columns[3]
[KMO.KDataType]::ScriptToSql($myColumn.DataType)
